︠c43a60e2-3496-4e22-a218-61580f294933︠
#Mini-project: Euler's line
reset
︡b9b9db6b-54e4-443a-8905-9550f881f431︡{"stdout":"<function reset at 0x7fc9193df050>\n"}︡{"done":true}
︠51901283-031b-4723-9f4d-3938ee306263s︠
#Part 1

#Center of mass of a triangle
#//Imput:?
#//Output:?
def center_of_mass(z1,z2,z3):# triangle ABC: C(z3),B(z2),A(z1);format:z=a+b*I
    m23=(z3+z2)/2 #Find the midpoint of AB
    # Use the remark from Lecture notes to calculate the center of mass
    cm=z1+(2/3)*(m23-z1)
    return [cm.real(),cm.imag()]
︡938dc285-fa99-4bbf-aefa-16550acd3985︡{"done":true}
︠7f3238a5-a885-41e3-a2e9-18e054a3855ds︠
#Example 
#Triangle ABC; A(u,v),B(a,0),C(0,0)
var('u v a');assume(u,'real');assume(v,'real');assume(a,'real');
︡33324422-f7e4-4cd1-a80b-af1e0c8a2f71︡{"stdout":"(u, v, a)\n"}︡{"done":true}
︠e43c4c0a-00cf-4512-813d-b80cac85d8ccs︠
center_of_mass(u+v*I,a+0*I,0+0*I)
︡d8794425-958c-4994-af31-486ed5db22c0︡{"stdout":"[1/3*a + 1/3*u, 1/3*v]\n"}︡{"done":true}
︠ac44c70f-25d2-44b6-9794-021b0fd58f3as︠
#Useful command: solving system of two linear equations
#solve?
#Example
sol=solve([2.3*x-3.*y+1.1==0.0,x+y-2.5==0.0],x,y,solution_dict=true);sol
︡0b4a3aa5-fc0b-4251-982e-e7c9dbdb578d︡{"stdout":"[{y: 137/106, x: 64/53}]\n"}︡{"done":true}
︠754d26b9-cf95-4a97-b134-d7531f9b084bs︠
[sol[0][x],sol[0][y]] #This is how you can access the solution values and make a list of these values
︡877c8192-4bd9-47df-a2a6-88217154c1a5︡{"stdout":"[64/53, 137/106]\n"}︡{"done":true}
︠6213bf41-a95e-43f8-ba56-5c0c4863f21e︠
#Useful function: line_eq(z,S) returns the lhs of the equation a*(x-x0)+b(y-y0)=0 of the line passing through a point z=x0+i*y0 and having normal [a,b]
def line_eq(z,n):
    return n[0]*(x-z.real())+n[1]*(y-z.imag())
︡b0fdd958-c22e-47cb-bc71-e5e7f9aea924︡
︠21ded173-1168-4c4b-970c-6adae47a59d7s︠
var('x y')
︡d4b67239-4d4c-47a3-b9b0-ed7ca5ee3b20︡{"stdout":"(x, y)\n"}︡{"done":true}
︠57b8187d-121f-4ea2-afb5-869c5175c52bs︠
#Example
line_eq(3+2*I,[3,-2])
︡9aaa8db1-c0de-4029-a83c-7cdbcb18cf09︡{"stdout":"3*x - 2*y - 5\n"}︡{"done":true}
︠838af53b-372e-4efa-92cd-433b8a82687e︠
#Orthocenter
def orthocenter(z1,z2,z3): #left hand sides of eqs of two heights of the triangle
    s23=z3-z2; n1=[s23.real(),s23.imag()]#encode coordinates of a normal of the height from point z1
    expr1=line_eq(z1,n1) # lhs of eq of height from vertex z1
    s13=z3-z1; n2=[s13.real(),s13.imag()]  #encode coordinated of a normal of the height from point z2
    expr2=line_eq(z2,n2) # lhs of eq of height from vertex z2
    sol=solve([expr1==0,expr2==0],x,y,solution_dict=True)  #Orthocenter coordinates
    return [sol[0][x], sol[0][y]]

︡1b44e2c3-22be-49f2-afb7-402e3edb7127︡{"done":true}
︠655d10b6-c8b9-42bb-9a26-ab428c7a840es︠
pt1=5+3*I;pt2=4+0*I;pt3=0+0*I
︡45a2cdf4-d6af-4fe3-bf10-1f1919a0fde7︡{"done":true}
︠9ea6065f-f5f9-4366-a2a8-6687ec18d7afs︠
O=orthocenter(pt1,pt2,pt3);O
︡fc0ec0ce-0c22-4c12-9444-87add5051fac︡{"stdout":"[5, -5/3]\n"}︡{"done":true}
︠250b9dca-f3eb-4066-80ca-38371da8b503︠
#Center of circumscribed circle
def bisector_cross(z1,z2,z3):
    m23=(z3+z2)/2
    s23=z3-z2; n1=[s23.real(),s23.imag()] #Normal to bicector erected from the midpoint of the side connecting z3 and z2
    expr1=line_eq(m23,n1)
    m13=(z1+z3)/2
    s13=z3-z1;n2=[s13.real(),s13.imag()]  #Normal to bicector erected from the midpoint of the side connecting z3 and z1
    expr2=line_eq(m13,n2)
    sol=solve([expr1==0,expr2==0],x,y,solution_dict=True)#Coordinates of the bisector intersection
    return [sol[0][x], sol[0][y]]
︡71e4882d-d3b6-4261-abb0-2139d0426a9a︡{"done":true}
︠16cb66f9-7701-4d09-9d49-7881543337a2︠
#Part 2.
#(a) Show manually that the three special points of the triangle ABC with A=pt1, B=pt2, C=pt3,lie on a line
︡71159beb-0543-4244-8c6b-c71898741b3e︡
︠1785eba7-ec4a-48e8-b55f-df6ac46132acs︠
#C=bisector_cross(pt1,pt2,pt3);C
︡0cbde65e-881b-436e-91af-2ae35e3485a6︡{"done":true}
︠c2cc12ae-a6fe-4d8f-8103-410a5be16458s︠
#M=center_of_mass(pt1,pt2,pt3);M
︡f01f9582-f1b3-47f2-8c78-0efe984f19fa︡{"done":true}
︠ed7d233a-a883-43e5-9c30-aa5096faeac5s︠
#H=orthocenter(pt1,pt2,pt3);H
︡f316b805-8b5b-4ec7-888c-b62decb67ed0︡{"done":true}
︠0f9529bf-8941-45e4-9ce3-89c94cbfe2ff︠
#(b) Prove that the special points of the triangle ABC with A=u+I*v, B=a, C=0+0*I,lie on a line
︡7e85f788-df56-4447-8b12-b7ba530f699e︡{"done":true}
︠929e7900-1442-4b08-b52b-c13a6ff9a535︠
var('u v a');assume(u,'real');assume(v,'real');assume(a,'real');
︡4f99d8a8-b94f-4e08-94fd-0cd506a99ea0︡{"stdout":"(u, v, a)\n"}︡{"done":true}
︠5fd2f6bb-fa11-4ff7-85d7-c5635dc145c4︠
A=u+I*v; B=a+I*0; C=0+0*I
︡6d97cec8-9ef4-47c0-bad4-240398d42335︡{"done":true}
︠91103506-f791-43d9-8808-7b06a25f9dcf︠
Find the center of mass,cm, the orthocenter,oc, and the bisector intercection,bc
︡f2954cd4-2f35-4ee4-9b1c-8004b6796550︡
︠478035da-3e50-48e6-91a7-277d93cfd2a5︠
cm=?
oc=?
bc=?
︡89fa22ae-8e16-4870-9e7c-bb8eabeb345e︡{"stdout":"[1/3*a + 1/3*u, 1/3*v]\n"}︡{"stdout":"[u, (a*u - u^2)/v]\n"}︡{"stdout":"[1/2*a, -1/2*(a*u - u^2 - v^2)/v]\n"}︡{"done":true}
︠8bb158a9-790e-474a-8e7d-77d38c741eeb︠
var('x y')
︡6ca4b9dc-c3c5-4304-8401-a8665a903798︡{"stdout":"(x, y)\n"}︡{"done":true}
︠5b4e77f6-7c3f-4f99-a6cf-179bb12f6bdd︠
#Line through two points, cm and oc
z=? #convert the center of mass into complex number
S=[oc[0]-cm[0],oc[1]-cm[1]]#Find a direction vector of the line
n=[?,?]# Find a normal to the line
euler=line_eq(?,?);euler #lhs of the line equation
︡bbfd1db0-4e21-4667-a940-bc7d2e9121be︡{"stdout":"-1/9*(a - 2*u)*(v - 3*y) + 1/9*(a + u - 3*x)*(v - 3*(a*u - u^2)/v)\n"}︡{"done":true}
︠5d0b3930-9119-4ebb-9f95-d3df6ae6f28a︠
test=euler.subs(x=?,y=?)# Check if the line passes through the intersection of bisectors
︡071144de-5c62-4262-9739-67e6dba16b77︡{"done":true}
︠ae7725bb-8b7b-4447-b34e-b68dcbeb2d66︠
test.expand()
︡d4e44783-7f3c-4ad0-a29b-79dda6a3acb2︡{"stdout":"0\n"}︡{"done":true}
︠0a13520c-f345-483c-9663-af5f30e758eb︠
#Part 3: Plotting
# Use command 'point' to plot the three points
# Use command 'line' to plot Euler's line
# Use command polygon2d for plotting the triangle ABC. Choose any coordinates for the vertices provided the vertices do not lie on a line.
#Show all three plots in one figure. Add legend to the line if you want.
︡c969f929-8734-4004-aa68-bb1f5e6a8016︡
︠6670f0fe-8881-4053-a82d-3840770f5006s︠
var('a')
var('b')
var('c')
︡e3d4fff3-6599-4158-a8ae-240edf489661︡{"stdout":"a\n"}︡{"stdout":"b\n"}︡{"stdout":"c\n"}︡{"done":true}
︠31d48c62-35d3-47b5-97ed-4b7793634b10s︠
pt_plot=point(a,size=30,color='red',figsize=[4,4],legend_label=a)
pt_plot=point(b,size=30,color='green',figsize=[4,4],legend_label=b)
pt_plot=point(c,size=30,color='blue',figsize=[4,4],legend_label=c)
triangle=polygon2d([[z1.real(),z1.imag()],[z2.real(),z2.imag()],[z2.real(),z2.imag()]],fill=False)
d=line([a,b,c],color='red',legend_label='Eulers line')
show(pt_plot+pt_plot1+pt_plot2+triangle+d)
pt1=5+4*I;
pt2=4+3*I;
pt3=3+2*I
plotting_euler(pt1,pt2,pt3)
plotting_euler(4+2*I,5+3*I,1+4*I)





︡290c6ba2-c491-43d6-87be-d441b125ff00︡{"stderr":"Error in lines 4-4\nTraceback (most recent call last):\n  File \"/cocalc/lib/python2.7/site-packages/smc_sagews/sage_server.py\", line 1191, in execute\n    flags=compile_flags), namespace, locals)\n  File \"\", line 1, in <module>\nNameError: name 'z1' is not defined\n"}︡{"done":true}
︠a0cc1df2-97e1-40b5-84b9-edd7acfd0444︠
#Mini-project: Euler's line
reset
︡e13696a1-56fd-4b35-b041-b440af8bd292︡{"stdout":"<function reset at 0x7fc9193df050>\n"}︡{"done":true}
︠3a2d5857-4269-434f-a290-6abca75f2fea︠
#Part 1

#Center of mass of a triangle
#//Imput:?
#//Output:?
def center_of_mass(z1,z2,z3):# triangle ABC: C(z3),B(z2),A(z1);format:z=a+b*I
    m23=? #Find the midpoint of AB
    # Use the remark from Lecture notes to calculate the center of mass
    cm=z1+(2/3)*(?)
    return [cm.real(),cm.imag()]
︡19546380-3564-4fa7-98da-215812c971a2︡{"done":true}
︠9cd59fab-04f7-4492-a406-6a336ce87014︠
#Example 
#Triangle ABC; A(u,v),B(a,0),C(0,0)
var('u v a');assume(u,'real');assume(v,'real');assume(a,'real');
︡e8515884-70e9-4b9a-9436-170a27f8e132︡{"stdout":"(u, v, a)\n"}︡{"done":true}
︠1f416e21-fd4a-4183-9867-acf5155994dd︠
center_of_mass(u+v*I,a+0*I,0+0*I)
︡cbde4e40-034a-45d6-9c11-7e34f704391a︡{"stdout":"[1/3*a + 1/3*u, 1/3*v]\n"}︡{"done":true}
︠bd4a075c-78a8-4f20-9dc4-1d8e65c2f56b︠
#Useful command: solving system of two linear equations
#solve?
#Example
sol=solve([2.3*x-3.*y+1.1==0.0,x+y-2.5==0.0],x,y,solution_dict=true);sol
︡ba87b137-01ca-4ed4-8fd8-17a8ecc17fe0︡{"stdout":"[{y: 137/106, x: 64/53}]\n"}︡{"done":true}
︠8084519d-a4fb-4871-bec8-ec6815c2495e︠
[sol[0][x],sol[0][y]] #This is how you can access the solution values and make a list of these values
︡886e2d95-898b-42ad-b21a-5de95d5a1f87︡{"stdout":"[64/53, 137/106]\n"}︡{"done":true}
︠b1ace2fe-48aa-4f7f-972c-c24cf1004846︠
#Useful function: line_eq(z,S) returns the lhs of the equation a*(x-x0)+b(y-y0)=0 of the line passing through a point z=x0+i*y0 and having normal [a,b]
def line_eq(z,n):
    return n[0]*(x-z.real())+n[1]*(y-z.imag())
︡73b05ca0-0a0f-4db0-bcd2-002bf8e9b08b︡{"done":true}
︠5e1ee949-61dd-4d80-af4c-d09d71219448︠
#Example
line_eq(3+2*I,[3,-2])
︡275af516-5c62-48ac-93d3-f7856ef429cb︡{"stdout":"3*x + 2*y - 13\n"}︡{"done":true}
︠fca6f72f-a52c-4f5c-811c-85fd97ee3bff︠
#Orthocenter
def orthocenter(z1,z2,z3):
    #left hand sides of eqs of two heights of the triangle
    s23=z3-z2 n1=[?,?]#encode coordinates of a normal of the height from point z1
    expr1=line_eq(?,?)# lhs of eq of height from vertex z1
    s13=z3-z1; n2=[?,?]#encode coordinated of a normal of the height from point z2
    expr2=line_eq(?,?)# lhs of eq of height from vertex z2
    sol=solve([expr1==0,expr2==0],x,y,solution_dict=True)#Orthocenter coordinates
    return [sol[0][x], sol[0][y]]

︡c3f09678-0d52-433a-9be4-76f917d09ad2︡{"done":true}
︠b9c6ec45-c3b4-42b1-9ea4-030f0e00fb56︠
pt1=5+3*I;pt2=4+0*I;pt3=0+0*I
︡f881d180-172e-4e38-b87e-37f467bb3648︡{"done":true}
︠294e8fe9-fcc6-4dee-a719-b969080d2a7a︠
O=orthocenter(pt1,pt2,pt3);O
︡e066c7a8-1eef-4141-8ca1-aa416882e956︡{"stdout":"[5, -5/3]\n"}︡{"done":true}
︠f9b13fbb-f938-4ce1-8bdf-379ef9f6b01b︠
#Center of circumscribed circle
def bisector_cross(z1,z2,z3):
    m23=(z3+z2)/2
    s23=z3-z2; n1=? #Normal to bicector erected from the midpoint of the side connecting z3 and z2
    expr1=line_eq(m23,n1)
    m13=(z1+z3)/2
    s13=z3-z1;n2=?#Normal to bicector erected from the midpoint of the side connecting z3 and z1
    expr2=line_eq(m13,n2)
    sol=solve([expr1==0,expr2==0],x,y,solution_dict=True)#Coordinates of the bisector intersection
    return [sol[0][x], sol[0][y]]
︡5c6e7069-21c9-410f-9709-a242a62c17c0︡{"done":true}
︠aba33dbb-7487-4c3a-9d81-c7029f3f34b7︠
#Part 2.
#(a) Show manually that the three special points of the triangle ABC with A=pt1, B=pt2, C=pt3,lie on a line
︡56465a87-8d93-48b2-9357-33734e22ccd5︡
︠1ca4169d-deba-4675-b0ad-390374d0211cs︠
#C=bisector_cross(pt1,pt2,pt3);C
︡dbf4c001-de67-4d16-a48d-bee2206d615c︡{"done":true}
︠08325400-9ee3-4227-9dc8-17056a78d810s︠
#M=center_of_mass(pt1,pt2,pt3);M
︡0f1f5624-54cf-4b1e-bd9f-e6f891360ebd︡{"done":true}
︠d917ad65-453f-4eb4-96fa-2fff431570d7s︠
#H=orthocenter(pt1,pt2,pt3);H
︡efc5e69e-eee2-4d9a-a098-aeee7ce4b80b︡{"done":true}
︠7c6ed3b3-1dd1-4bf7-a9cb-a08628d2f994︠
#(b) Prove that the special points of the triangle ABC with A=u+I*v, B=a, C=0+0*I,lie on a line
︡5dc8610b-cf2a-4719-9b1a-3f3ee209fe94︡{"done":true}
︠e09714b7-92a7-4777-804c-5425d2bac17d︠
var('u v a');assume(u,'real');assume(v,'real');assume(a,'real');
︡4d22d48b-cc1f-47aa-b179-8ec689788ac0︡{"stdout":"(u, v, a)\n"}︡{"done":true}
︠e06c083b-a01b-4d0b-adbb-1340612379be︠
A=u+I*v; B=a+I*0; C=0+0*I
︡d7cc8098-5413-479b-9d6e-fc82e8455a0c︡{"done":true}
︠fc927458-d201-4835-9640-1447f48f484f︠
Find the center of mass,cm, the orthocenter,oc, and the bisector intercection,bc
︡aaf7d3cf-4f60-47b8-bf8b-30ea73a1fc6b︡
︠ab1a2ae9-1049-4636-af1d-503ca3baf0ef︠
cm=?
oc=?
bc=?
︡9b03a11e-2cd7-4075-b960-b2d5d6217eed︡{"stdout":"[1/3*a + 1/3*u, 1/3*v]\n"}︡{"stdout":"[u, (a*u - u^2)/v]\n"}︡{"stdout":"[1/2*a, -1/2*(a*u - u^2 - v^2)/v]\n"}︡{"done":true}
︠c642689e-35d8-4936-8a1f-b3a7eb2877d4︠
var('x y')
︡14409461-1f00-4d01-8f9b-255521dfa805︡{"stdout":"(x, y)\n"}︡{"done":true}
︠dd513ff5-e01c-4c2b-8e0d-240ac526ddb7︠
#Line through two points, cm and oc
z=? #convert the center of mass into complex number
S=[oc[0]-cm[0],oc[1]-cm[1]]#Find a direction vector of the line
n=[?,?]# Find a normal to the line
euler=line_eq(?,?);euler #lhs of the line equation
︡07acfc5a-17aa-4e33-9696-5511c0e18312︡{"stdout":"-1/9*(a - 2*u)*(v - 3*y) + 1/9*(a + u - 3*x)*(v - 3*(a*u - u^2)/v)\n"}︡{"done":true}
︠8ace3f2c-19e2-43d7-8960-fd7fe81bdf54︠
test=euler.subs(x=?,y=?)# Check if the line passes through the intersection of bisectors
︡03897218-682d-42dc-8110-81c875b185a6︡{"done":true}
︠fd31e1ed-021e-4b04-8905-2716f2b601dd︠
test.expand()
︡15df575b-4f97-4eb1-a1df-c43ef10e6e16︡{"stdout":"0\n"}︡{"done":true}
︠d4169f02-60b0-4109-ade4-d9130aed3660︠
#Part 3: Plotting
# Use command 'point' to plot the three points
# Use command 'line' to plot Euler's line
# Use command polygon2d for plotting the triangle ABC. Choose any coordinates for the vertices provided the vertices do not lie on a line.
#Show all three plots in one figure. Add legend to the line if you want.
︠ff98d647-1c69-4b61-ba0b-547243d8d404︠









